import tkinter as tk
import sys
from tkinter import messagebox
from tkinter import *
from math import log, exp, log10, tan, asin, atan, pi, e, sqrt, acos, cos, sin, pow

class App:
    __NOOP  = -1
    __PLUS  =  0
    __MINUS =  1
    __TIMES =  2
    __DIV   =  3
    __TERM  =  4
    __LOAN  =  5
    __INT   =  6
    __PMT   =  7
    __FAC   =  8
    __SIN   =  9
    __COS   =  10
    __TAN   =  11
    __PI    =  12
    __LN    =  13
    __EXP   =  14
    __X2Y   =  15
    __INV   =  16
    __INX   =  17
    __CYCL  =  18
    __Y     =  19
    __FVAL  =  20
    __MS1   =  21
    __MS2   =  22
    __MR1   =  23
    __MR2   =  24
    __L10   =  25
    __AVG   =  26
    __SQRT  =  27
    __SQR   =  28
    __RAD   =  29
    __EE    =  30
    __TERMmsg  =  31
    __LOANmsg  =  32
    __INTmsg   =  33
    __PMTmsg   =  34
    __CYCLmsg  =  35
    __FVALmsg  =  36
    __EEmsg    =  37
    __DELmsg   =  38
    __INVmsg   =  39

    def __init__(self, master):
        self.master = master

        # Create a Tkinter variable to hold the displayed text
        # and set it to "0"
        self.display = StringVar(master)
        self.display.set("0")
        self.displayrd  = StringVar(master)
        self.displayrd.set("DEG")
        # Also keep the previous result (initially 0)
        self.prevRes = 0.0
        self.prevFcn = 0.0
        self.y       = 0.0
        self.term    = 0.0
        self.loan    = 0.0
        self.cycl    = 0.0
        self.intrst  = 0.0
        self.inv     = 0.0
        self.pmt     = 0.0
        self.fval    = 0.0
        self.msv1    = 0.0
        self.msv2    = 0.0
        self.rad     = 0.0
        self.pan     = 0.0
        self.save1   = 0.0
        self.save2   = 0.0
        
        # Flag which indicates next digit starts a new number
        self.cleardisp = TRUE
        # Flag to indicate that the number is < 0
        self.isneg = FALSE

        # Keep track of the current operation
        self.currop = App.__NOOP
        self.fnctop = App.__NOOP

        # Keep track of presence of dot in the number
        self.seendot = FALSE

        # Create and arrange widgets
        self.createWidgets(master)

        # Standardize button sizes, since the default
        # behaviour is to accomodate the caption
        # (also make the buttons resize with the form)
        xsize, ysize = master.grid_size()
        for i in range(0, ysize):
          master.grid_rowconfigure(i, minsize=30, weight=1)

        for i in range(xsize):
          master.grid_columnconfigure(i, minsize=45, weight=1)

        # Bind Events to Widgets
        self.bindWidgets()

    def createWidgets(self, master):
        # Create the necessary widgets
        self.btn0     = Button(master, height=1, width=2, fg='blue', text='0')
        self.btn1     = Button(master, height=1, width=2, fg='blue', text='1')
        self.btn2     = Button(master, height=1, width=2, fg='blue', text='2')
        self.btn3     = Button(master, height=1, width=2, fg='blue', text='3')
        self.btn4     = Button(master, height=1, width=2, fg='blue', text='4')
        self.btn5     = Button(master, height=1, width=2, fg='blue', text='5')
        self.btn6     = Button(master, height=1, width=2, fg='blue', text='6')
        self.btn7     = Button(master, height=1, width=2, fg='blue', text='7')
        self.btn8     = Button(master, height=1, width=2, fg='blue', text='8')
        self.btn9     = Button(master, height=1, width=2, fg='blue', text='9')
        self.btnDot   = Button(master, height=1, width=2, fg='blue', text='.', command=self.btnDotClick)
        self.btnDigits = (self.btn0, self.btn1, self.btn2, self.btn3, self.btn4,
                          self.btn5, self.btn6, self.btn7, self.btn8, self.btn9 )
        self.btnCycl = Button(master, height=1, width=2, fg='blue', text='Cycl')
        self.btnTerm  = Button(master, height=1, width=2, fg='blue', text='Term')
        self.btnLoan  = Button(master, height=1, width=2, fg='blue', text='Loan')
        self.btnFval  = Button(master, height=1, width=2, fg='blue', text='Fval')
        self.btnInt  = Button(master, height=1, width=2, fg='blue', text='Int')
        self.btnPmt  = Button(master, height=1, width=2, fg='blue', text='Pmt')
        self.btnBusfcn = (self.btnCycl, self.btnTerm, self.btnLoan, self.btnFval,
                          self.btnInt, self.btnPmt )
        self.btnPlus  = Button(master, height=1, width=2, fg='blue', text='+')
        self.btnMinus = Button(master, height=1, width=2, fg='blue', text='-')
        self.btnTimes = Button(master, height=1, width=2, fg='blue', text='x')
        self.btnDiv   = Button(master, height=1, width=2, fg='blue', text='/')
        self.btnOps = (self.btnPlus, self.btnMinus, self.btnTimes, self.btnDiv) 
        self.btnY     = Button(master, height=1, width=2, fg='blue', text='y')
        self.btnFac  = Button(master, height=1, width=2, fg='blue', text='x!')
        self.btnSin  = Button(master, height=1, width=2, fg='blue', text='Sin')
        self.btnCos  = Button(master, height=1, width=2, fg='blue', text='Cos')
        self.btnTan  = Button(master, height=1, width=2, fg='blue', text='Tan')
        self.btnLog  = Button(master, height=1, width=2, fg='blue', text='Ln')
        self.btnPi   = Button(master, height=1, width=2, fg='blue', text='PI')
        self.btnExp  = Button(master, height=1, width=2, fg='blue', text='Exp')
        self.btnX2y  = Button(master, height=1, width=2, fg='blue', text='y^x')
        self.btnInv  = Button(master, height=1, width=2, fg='blue', text='Inv')
        self.btnInx  = Button(master, height=1, width=2, fg='blue', text='1/x')
        self.btnSqrt = Button(master, height=1, width=2, fg='blue', text='Sqrt')
        self.btnSqr  = Button(master, height=1, width=2, fg='blue', text='x^2')
        self.btnEe   = Button(master, height=1, width=2, fg='blue', text='( )')
        self.btnFns = (self.btnFac, self.btnSin, self.btnCos, self.btnTan,   
                       self.btnPi, self.btnLog, self.btnExp, self.btnX2y, self.btnInv, 
                       self.btnInx, self.btnY, self.btnSqrt, self.btnSqr, self.btnEe )
        self.btnNeg   = Button(master, height=1, width=2, fg='blue', text='+/-', command=self.btnNegClick)
        self.btnRes   = Button(master, height=1, width=2, fg='blue', text='=', command=self.btnResClick)
        self.btnDel   = Button(master, height=1, width=2, fg='blue', text="DEL", bg="yellow", command=self.btnDelClick)
        self.btnCE    = Button(master, height=1, width=2, fg='blue', text="CE", bg="yellow", command=self.btnCEClick)
        self.btnC     = Button(master, height=1, width=2, fg='blue', text="C", bg="gold", command=self.btnCClick)
        self.btnQuit  = Button(master, height=1, width=2, fg='blue', text='Quit', bg="yellow", command= self.btnQuitClick )
        self.btnAbout  = Button(master, height=1, width=2, fg='blue', text='Help', command= self.AboutClick )
        self.lblDisp  = Label(master, height=1, width=2, fg='blue', textvariable=self.display, anchor=E, relief=SUNKEN, bg="white")
        self.lblDisp1 = Label(master, height=1, width=2, fg='blue', textvariable=self.displayrd, anchor=W, relief=SUNKEN, bg="white")
        self.btnMs1  = Button(master, height=1, width=2, fg='blue', text='Ms1')
        self.btnMs2  = Button(master, height=1, width=2, fg='blue', text='M++')
        self.btnL10  = Button(master, height=1, width=2, fg='blue', text='log')
        self.btnRad  = Button(master, height=1, width=2, fg='blue', text='DgRd')
        self.btnMr1  = Button(master, height=1, width=2, fg='blue', text='Mr1')
        self.btnMr2  = Button(master, height=1, width=2, fg='blue', text='M--')
        self.btnMemory = (self.btnMs1, self.btnMs2, self.btnL10, self.btnMr1,
                          self.btnMr2, self.btnRad,
                          self.btnMr1, self.btnMr2 )


        # Use the Grid Geomatry manager to arrange the widgets
        self.lblDisp1.grid(row=0, column=0, columnspan=1, sticky=NSEW)
        self.lblDisp.grid(row=0, column=1, columnspan=5, sticky=NSEW)
        self.btnC.grid(row=1, column=0, sticky=NSEW)
        self.btnCE.grid(row=1, column=1, sticky=NSEW)
        self.btnDel.grid(row=1, column=2, sticky=NSEW)
        self.btnRad.grid(row=1, column=3, sticky=NSEW)
        self.btnAbout.grid(row=1, column=4, sticky=NSEW)
        self.btnQuit.grid(row=1, column=5, sticky=NSEW)
        self.btnMs1.grid(row=2, column=0, sticky=NSEW)
        self.btnMs2.grid(row=2, column=1, sticky=NSEW)
        self.btnMr1.grid(row=2, column=2, sticky=NSEW)
        self.btnMr2.grid(row=2, column=3, sticky=NSEW)
        self.btnInv.grid(row=2, column=4, sticky=NSEW)
        self.btnPi.grid(row=2, column=5, sticky=NSEW)
        self.btnSin.grid(row=3, column=0, sticky=NSEW)
        self.btn1.grid(row=3, column=1, sticky=NSEW)
        self.btn2.grid(row=3, column=2, sticky=NSEW)
        self.btn3.grid(row=3, column=3, sticky=NSEW)
        self.btnTimes.grid(row=3, column=4, sticky=NSEW)
        self.btnDiv.grid(row=3, column=5, sticky=NSEW)
        self.btnCos.grid(row=4, column=0, sticky=NSEW)
        self.btn4.grid(row=4, column=1, sticky=NSEW)
        self.btn5.grid(row=4, column=2, sticky=NSEW)
        self.btn6.grid(row=4, column=3, sticky=NSEW)
        self.btnPlus.grid(row=4, column=4,  sticky=NSEW)
        self.btnMinus.grid(row=4, column=5, sticky=NSEW)
        self.btnTan.grid(row=5, column=0, sticky=NSEW)
        self.btn7.grid(row=5, column=1, sticky=NSEW)
        self.btn8.grid(row=5, column=2, sticky=NSEW)
        self.btn9.grid(row=5, column=3, sticky=NSEW)
        self.btnRes.grid(row=5, column=4, sticky=NSEW)
        self.btnInx.grid(row=5, column=5, sticky=NSEW)
        self.btnLog.grid(row=6, column=0, sticky=NSEW)
        self.btnExp.grid(row=6, column=1, sticky=NSEW)
        self.btn0.grid(row=6, column=2, sticky=NSEW)
        self.btnDot.grid(row=6, column=3, sticky=NSEW)
        self.btnFac.grid(row=6, column=4, sticky=NSEW)
        self.btnY.grid(row=6, column=5, sticky=NSEW)
        self.btnSqrt.grid(row=7, column=0, sticky=NSEW)
        self.btnSqr.grid(row=7, column=1, sticky=NSEW)
        self.btnX2y.grid(row=7, column=2, sticky=NSEW)
        self.btnEe.grid(row=7, column=3, sticky=NSEW)
        self.btnNeg.grid(row=7, column=4, sticky=NSEW)
        self.btnL10.grid(row=7, column=5, sticky=NSEW)
        self.btnCycl.grid(row=8, column=0, sticky=NSEW)
        self.btnTerm.grid(row=8, column=1, sticky=NSEW)
        self.btnInt.grid(row=8, column=2, sticky=NSEW)
        self.btnPmt.grid(row=8, column=3, sticky=NSEW)
        self.btnLoan.grid(row=8, column=4, sticky=NSEW)
        self.btnFval.grid(row=8, column=5, sticky=NSEW)

    def bindWidgets(self):
        for w in self.btnDigits:
            w.bind('<1>', self.btnDigitClick)

        for w in self.btnMemory:
            w.bind('<1>', self.btnMemClick)

        for w in self.btnOps:
            w.bind('<1>', self.btnOpClick)

        for w in self.btnBusfcn:
            w.bind('<1>', self.btnBusFnClick)

        for w in self.btnFns:
            w.bind('<1>', self.btnFnClick)

        for w in self.btnBusfcn:
            w.bind('<3>', self.btnBusMsgClick )

        self.btnEe.bind('<3>', self.btnBusMsgClick )

        self.btnDel.bind('<3>', self.btnBusMsgClick )

        self.btnInv.bind('<3>', self.btnBusMsgClick )

    def btnDigitClick(self, event):
        if self.cleardisp:
            if self.isneg:
                self.display.set('-' + event.widget.cget('text'))
            else:
                self.display.set(event.widget.cget('text'))
        else:
            self.display.set(self.display.get() + event.widget.cget('text'))
        if not (self.cleardisp and event.widget == self.btn0):
            self.cleardisp = FALSE

    def btnDotClick(self):
        if not self.seendot:
          if self.cleardisp:
            if self.isneg:
                self.display.set('-' + '.')
            else:
                self.display.set('.')
          else:
            self.display.set(self.display.get() + '.' )
            self.seendot = TRUE
        self.cleardisp = FALSE
    
    def btnMemClick(self, event):
        if event.widget == self.btnMs1:
            self.fnctop = App.__MS1 
        if event.widget == self.btnMs2:
            self.fnctop = App.__MS2 
        if event.widget == self.btnMr1:
            self.fnctop = App.__MR1 
        if event.widget == self.btnMr2:
            self.fnctop = App.__MR2 
        if event.widget == self.btnL10:
            self.fnctop = App.__L10 
        if event.widget == self.btnRad:
            self.fnctop = App.__RAD 
        self.btnFcnResClick()

    def btnOpClick(self, event):
        self.btnResClick()
        if event.widget == self.btnPlus:
            self.currop = App.__PLUS
        elif event.widget == self.btnMinus:
            self.currop = App.__MINUS
        elif event.widget == self.btnTimes:
            self.currop = App.__TIMES
        elif event.widget == self.btnDiv:
            self.currop = App.__DIV

    def btnBusFnClick(self, event):
        if event.widget == self.btnTerm:
            self.fnctop = App.__TERM
        elif event.widget == self.btnLoan:
            self.fnctop = App.__LOAN
        elif event.widget == self.btnInt:
            self.fnctop = App.__INT
        elif event.widget == self.btnPmt:
            self.fnctop = App.__PMT
        elif event.widget == self.btnCycl:
            self.fnctop = App.__CYCL
        elif event.widget == self.btnFval:
            self.fnctop = App.__FVAL
        self.btnFcnResClick()

    def btnBusMsgClick(self, event):
        if event.widget == self.btnTerm:
            self.fnctop = App.__TERMmsg
        elif event.widget == self.btnLoan:
            self.fnctop = App.__LOANmsg
        elif event.widget == self.btnInt:
            self.fnctop = App.__INTmsg
        elif event.widget == self.btnPmt:
            self.fnctop = App.__PMTmsg
        elif event.widget == self.btnCycl:
            self.fnctop = App.__CYCLmsg
        elif event.widget == self.btnFval:
            self.fnctop = App.__FVALmsg
        elif event.widget == self.btnEe:
            self.fnctop = App.__EEmsg
        elif event.widget == self.btnDel:
            self.fnctop = App.__DELmsg
        elif event.widget == self.btnInv:
            self.fnctop = App.__INVmsg
        self.btnShowMsgClick()

    def btnShowMsgClick(self):
            if self.fnctop == App.__CYCLmsg:
               tkMessageBox.showinfo("Cycle", "The payment cycle in a year. For example, input 12 for monthly payments.")
            if self.fnctop == App.__TERMmsg:
               tkMessageBox.showinfo("Term", "The duration of loan in years.")
            elif self.fnctop == App.__LOANmsg:
               tkMessageBox.showinfo("Loan", "The amount of money borrwed or invested.")
            elif self.fnctop == App.__INTmsg:
               tkMessageBox.showinfo("Interest", "The annual interest rate.")
            elif self.fnctop == App.__PMTmsg:
               tkMessageBox.showinfo("Payment", "The payment per period. To calculate a payment enter 0 and press PMT button after filling other relevant parameters. Input paymets desired for future value calculations.")
            elif self.fnctop == App.__FVALmsg:
               tkMessageBox.showinfo("Future Value", "Enter 0 and left click this button to get the future values after filling other relevant numbers. Input a desired vaule for annuity payment calculations.")
            elif self.fnctop == App.__EEmsg:
               tkMessageBox.showinfo("Parenthesis", "A left click on this button starts a new calculation process. After finishing the usual operations, you must click = button and finally close the operations with the left click on this button")
            elif self.fnctop == App.__DELmsg:
               tkMessageBox.showinfo("Backspace", "A left click on this button deletes the last chracter in display")
            elif self.fnctop == App.__INVmsg:
               tkMessageBox.showinfo("Inverse", "This button function together with sin, cos, etc is used to calculate asin, acos etc")

    def btnFnClick(self, event):
        if event.widget == self.btnFac:
            self.fnctop = App.__FAC
        elif event.widget == self.btnSin:
            self.fnctop = App.__SIN
        elif event.widget == self.btnCos:
            self.fnctop = App.__COS
        elif event.widget == self.btnTan:
            self.fnctop = App.__TAN
        elif event.widget == self.btnPi: 
            self.fnctop = App.__PI 
        elif event.widget == self.btnLog:
            self.fnctop = App.__LN 
        elif event.widget == self.btnExp:
            self.fnctop = App.__EXP
        elif event.widget == self.btnX2y:
            self.fnctop = App.__X2Y
        elif event.widget == self.btnInv:
            self.fnctop = App.__INV
        elif event.widget == self.btnInx:
            self.fnctop = App.__INX
        elif event.widget == self.btnY:
            self.fnctop = App.__Y
        if event.widget == self.btnSqrt:
            self.fnctop = App.__SQRT
        if event.widget == self.btnSqr:
            self.fnctop = App.__SQR 
        if event.widget == self.btnEe:
            self.fnctop = App.__EE
        self.btnFcnResClick()

    def btnNegClick(self):
        disp = self.display.get()
        if disp[0] == '-':
           self.display.set(disp[1:])
        else:
            self.display.set('-' + disp)
        self.isneg = not self.isneg

    def btnResClick(self):
        try:
            f = float(self.display.get())
            if self.currop == App.__PLUS:
                self.prevRes = self.prevRes + f
            elif self.currop == App.__MINUS:
                self.prevRes = self.prevRes - f
            elif self.currop == App.__TIMES:
                self.prevRes = self.prevRes * f
            elif self.currop == App.__DIV:
                self.prevRes = self.prevRes / f
            else:
                self.prevRes = f
            if self.prevRes == float(self.prevRes):
                self.prevRes = float(self.prevRes)
            self.display.set(str(self.prevRes))
        except:
            # An error has occured
            self.display.set("ERR")
            self.prevRes = 0.0
        self.currop = App.__NOOP
        self.cleardisp = TRUE
        self.seendot = FALSE
        self.isneg = FALSE

    def btnFcnResClick(self):
        try:
            g = float(self.display.get())
            if self.fnctop == App.__FAC:
                self.prevFcn =   self.fact(g)
            elif self.fnctop == App.__SQRT:
                self.prevFcn =   sqrt(g)
            elif self.fnctop == App.__RAD:
             if ( self.rad  == 0 ):
                self.rad  =  1 
                self.displayrd.set("RAD")
             elif ( self.rad  == 1 ):
                self.rad  =  0 
                self.displayrd.set("DEG")
            elif self.fnctop == App.__SIN:
              if ( self.inv == 0 ):
                if ( self.rad == 0):
                  g = pi*g/180.0
                self.prevFcn =  sin(g)
              elif ( self.inv == 1 ):
                if ( self.rad == 0):
                  self.prevFcn =  asin(g)*(180.0/pi)
                elif ( self.rad == 1):
                  self.prevFcn =  asin(g)
                self.inv     = 0
            elif self.fnctop == App.__COS:
              if ( self.inv == 0 ):
                if ( self.rad == 0):
                  g = pi*g/180.0
                self.prevFcn =  cos(g)
              elif ( self.inv == 1 ):
                if ( self.rad == 0):
                   self.prevFcn =  acos(g)*(180.0/pi)
                elif ( self.rad == 1):
                   self.prevFcn =  acos(g)
                self.inv     = 0
            elif self.fnctop == App.__TAN:
              if ( self.inv == 0 ):
                if ( self.rad == 0):
                  g = pi*g/180.0
                self.prevFcn =  tan(g)
              elif ( self.inv == 1 ):
                if ( self.rad == 0):
                  self.prevFcn =  atan(g)*(180.0/pi)
                elif ( self.rad == 1):
                  self.prevFcn =  atan(g)
                self.inv     = 0
            elif self.fnctop == App.__PI:
                self.prevFcn =   pi 
            elif self.fnctop == App.__LN: 
                self.prevFcn =   log(g) 
            elif self.fnctop == App.__EXP:
                self.prevFcn =   exp(g) 
            elif self.fnctop == App.__X2Y:
                self.prevFcn =   pow(self.y,g)
            elif self.fnctop == App.__INV:
                self.prevFcn =  g
                self.inv     =   1 
            elif self.fnctop == App.__INX:
                self.prevFcn =   1./g 
            elif self.fnctop == App.__Y:
                self.y = g
            elif self.fnctop == App.__CYCL:
                self.cycl    =  g
                self.prevFcn =  g 
            elif self.fnctop == App.__TERM:
                self.term =  self.cycl* g
                self.prevFcn = self.cycl* g
            elif self.fnctop == App.__LOAN:
                self.loan =   g
                self.prevFcn = g
            elif self.fnctop == App.__INT:
                self.intrst  =  g/(100*self.cycl)
                self.prevFcn =  g/(100*self.cycl)
            elif self.fnctop == App.__PMT:
              if ( g == 0 and self.fval == 0 ):
                self.prevFcn =   self.pmtf(self.term, self.intrst, self.loan )
              elif (g != 0 and self.fval == 0 ):
                self.pmt     =  g 
                self.prevFcn =  g
              elif (self.fval != 0 ):
                self.prevFcn =   self.pmtan(self.term, self.intrst, self.fval )
              else:
                self.pmt     =  g 
                self.prevFcn =  g
            elif self.fnctop == App.__FVAL:
              if ( g == 0 and self.pmt == 0 ):
                self.fval =   self.fviv(self.term, self.intrst, self.loan )
                self.prevFcn =  self.fval 
              elif ( g == 0 and self.pmt != 0 ):
                self.fval =   self.fvan(self.term, self.intrst, self.pmt )
                self.prevFcn =  self.fval 
              else:
                self.fval =     g
                self.prevFcn =  self.fval 
            elif self.fnctop == App.__MS1:
                self.msv1 = g
            elif self.fnctop == App.__MS2:
                self.msv2 = g + self.msv2
                self.prevFcn =  self.msv2
            elif self.fnctop == App.__MR1:
                self.prevFcn =  self.msv1
            elif self.fnctop == App.__MR2:
                self.msv2 = -g + self.msv2
                self.prevFcn =  self.msv2
            elif self.fnctop == App.__L10:
                self.prevFcn = log10(g)
            elif self.fnctop == App.__SQR:
                self.prevFcn =  g*g
            elif self.fnctop == App.__EE:
             if ( self.pan  == 0 ):
                self.pan  =  1 
                self.displayrd.set(self.displayrd.get() + "  ()")
                self.save1 = self.prevRes
                self.save2 = self.currop
                self.prevRes = 0
                self.currop = App.__NOOP 
             elif ( self.pan  == 1 ):
                self.pan  =  0
                self.prevFcn =  g
                self.currop = self.save2 
                self.prevRes = self.save1
                if self.rad  ==  1: 
                  self.displayrd.set("RAD")
                elif self.rad  ==  0: 
                  self.displayrd.set("DEG")
            else:
                self.prevFcn = g
            if self.prevFcn == float(self.prevFcn):
                self.prevFcn = float(self.prevFcn)
            self.display.set(str(self.prevFcn))
        except:
            # An error has occured
            self.display.set("ERR")
            self.prevFcn = 0.0
            self.prevRes = 0.0
            self.term    = 0.0
            self.loan    = 0.0
            self.intrst  = 0.0
            self.pmt     = 0.0
        self.fnctop = App.__NOOP
        self.cleardisp = TRUE
        self.seendot = FALSE
        self.isneg = FALSE


    def AboutClick(self):
        tkMessageBox.showinfo("About", "This is a basic Engineering-Business Calculator.  To get help, right click on a button. Help is provided for newer business related functions. All issues should be mailed at narain2@yahoo.com.  Thanks for using Jcalc based on python/Tkinter script.\n Date Aug. 15, 2003")

    def btnQuitClick(self):
        sys.exit(0)

    def btnCEClick(self):
        self.isneg = FALSE
        self.cleardisp = TRUE
        self.seendot = FALSE
        self.display.set('0')

    def btnDelClick(self):
        ans = "" 
        anq = "" 
        ans = self.display.get()
        x   = len(self.display.get()) - 1
        for i in range(x):
          anq =  anq + ans[i] 
        self.display.set(anq )
  

    def btnCClick(self):
        self.isneg = FALSE
        self.cleardisp = TRUE
        self.seendot = FALSE
        self.display.set('0')
        self.currop = App.__NOOP
        self.fnctop = App.__NOOP
        self.prevRes = 0.0
        self.prevFcn = 0.0
        self.term    = 0.0
        self.loan    = 0.0
        self.intrst  = 0.0
        self.pmt     = 0.0
        self.inv     = 0.0
        self.y       = 0.0
        self.fval    = 0.0
        self.msv1    = 0.0
        self.msv2    = 0.0
        self.rad     = 0.0
        self.displayrd.set("DEG")
        self.pan     = 0.0
        self.save1   = 0.0
        self.save2   = 0.0
        


    def pmtf(self, nper, ratex, loan):
        dum0 = 1. + ratex
        dum1 = pow(dum0, nper)
        dum2 = dum1 - 1.0
        if ( ratex > 0. ):
          dum3 = dum1*ratex
          dum4 = dum2/dum3
          pmt    = loan/dum4
        else:
          pmt    = loan/nper
        pmt = "%12.2f " % pmt
        return pmt 

    def fviv(self, nper, ratex, loan):
        dum0 = 1. + ratex
        dum1 = pow(dum0, nper)
        fval = loan*dum1
        fval = "%12.2f " % fval
        return fval

    def pmtan(self, nper, ratex, fval ):
        dum0 = 1. + ratex
        dum1 = pow(dum0, nper)
        dum2 = dum1 - 1.0
        dum3 = dum2/ratex
        pmt  = fval/dum3
        pmt = "%12.2f " % pmt
        return pmt 

    def fvan(self, nper, ratex, pmt ):
        dum0 = 1. + ratex
        dum1 = pow(dum0, nper)
        if ( ratex > 0. ):
          dum2 = dum1 - 1.0
          dum3 = dum0/ratex
          fval = pmt*dum2*dum3
        else:
          fval = pmt*dum1*nper
        fval = "%12.2f " % fval
        return fval

    def fact(self, n):
       m = 1
       n = int(n)
       for i in range(2,n+1): 
         m = float(m*i)
       return m
    
